diff --git a/rsvg-filter.c b/rsvg-filter.c
index 705f14c..81cce75 100644
--- a/rsvg-filter.c
+++ b/rsvg-filter.c
@@ -3295,8 +3831,8 @@ rsvg_new_filter_primitive_turbulence (void)
     filter->bDoStitching = 0;
     filter->bFractalSum = 0;
     feTurbulence_init (filter);
-    filter->super.render = &rsvg_filter_primitive_turbulence_render;
-    filter->super.super.free = &rsvg_filter_primitive_turbulence_free;
+    filter->super.render = rsvg_filter_primitive_turbulence_render;
+    filter->super.super.free = rsvg_filter_primitive_free;
     filter->super.super.set_atts = rsvg_filter_primitive_turbulence_set_atts;
     return (RsvgNode *) filter;
 }
@@ -3313,13 +3849,13 @@ struct _RsvgFilterPrimitiveImage {
     GString *href;
 };
 
-static GdkPixbuf *
+static cairo_surface_t *
 rsvg_filter_primitive_image_render_in (RsvgFilterPrimitive * self, RsvgFilterContext * context)
 {
     RsvgDrawingCtx *ctx;
     RsvgFilterPrimitiveImage *upself;
-    int i;
     RsvgNode *drawable;
+    cairo_surface_t *result;
 
     ctx = context->ctx;
 
@@ -3328,27 +3864,30 @@ rsvg_filter_primitive_image_render_in (RsvgFilterPrimitive * self, RsvgFilterCon
     if (!upself->href)
         return NULL;
 
-    drawable = rsvg_defs_lookup (ctx->defs, upself->href->str);
+    drawable = rsvg_acquire_node (ctx, upself->href->str);
     if (!drawable)
         return NULL;
 
-    for (i = 0; i < 6; i++)
-        rsvg_state_current (ctx)->affine[i] = context->paffine[i];
+    rsvg_current_state (ctx)->affine = context->paffine;
 
-    return rsvg_get_image_of_node (ctx, drawable, context->width, context->height);
+    result = rsvg_get_surface_of_node (ctx, drawable, context->width, context->height);
+
+    rsvg_release_node (ctx, drawable);
+
+    return result;
 }
 
-static GdkPixbuf *
+static cairo_surface_t *
 rsvg_filter_primitive_image_render_ext (RsvgFilterPrimitive * self, RsvgFilterContext * ctx)
 {
     RsvgIRect boundarys;
     RsvgFilterPrimitiveImage *upself;
-    GdkPixbuf *img;
+    cairo_surface_t *img, *intermediate;
     int i;
-    GdkPixbuf *intermediate;
     unsigned char *pixels;
     int channelmap[4];
     int length;
+    int width, height;
 
     upself = (RsvgFilterPrimitiveImage *) self;
 
@@ -3357,34 +3896,35 @@ rsvg_filter_primitive_image_render_ext (RsvgFilterPrimitive * self, RsvgFilterCo
 
     boundarys = rsvg_filter_primitive_get_bounds (self, ctx);
 
-    img = rsvg_pixbuf_new_from_href (upself->href->str,
-                                     rsvg_handle_get_base_uri (upself->ctx), NULL);
+    width = boundarys.x1 - boundarys.x0;
+    height = boundarys.y1 - boundarys.y0;
+    if (width == 0 || height == 0)
+        return NULL;
 
+    img = rsvg_cairo_surface_new_from_href (upself->ctx,
+                                            upself->href->str,
+                                            NULL);
     if (!img)
         return NULL;
 
-
-    intermediate = gdk_pixbuf_new (GDK_COLORSPACE_RGB, 1, 8, boundarys.x1 - boundarys.x0,
-                                   boundarys.y1 - boundarys.y0);
-
-
-    rsvg_art_affine_image (img, intermediate,
-                           ctx->paffine,
-                           (boundarys.x1 - boundarys.x0) / ctx->paffine[0],
-                           (boundarys.y1 - boundarys.y0) / ctx->paffine[3]);
-
-    if (!intermediate) {
-        g_object_unref (G_OBJECT (img));
+    intermediate = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, width, height);
+    if (cairo_surface_status (intermediate) != CAIRO_STATUS_SUCCESS ||
+        !rsvg_art_affine_image (img, intermediate,
+                                &ctx->paffine,
+                                (gdouble) width / ctx->paffine.xx,
+                                (gdouble) height / ctx->paffine.yy)) {
+        cairo_surface_destroy (intermediate);
+        cairo_surface_destroy (img);
         return NULL;
     }
 
+    cairo_surface_destroy (img);
 
-    g_object_unref (G_OBJECT (img));
-
-    length = gdk_pixbuf_get_height (intermediate) * gdk_pixbuf_get_rowstride (intermediate);
+    length = cairo_image_surface_get_height (intermediate) * 
+             cairo_image_surface_get_stride (intermediate);
     for (i = 0; i < 4; i++)
         channelmap[i] = ctx->channelmap[i];
-    pixels = gdk_pixbuf_get_pixels (intermediate);
+    pixels = cairo_image_surface_get_data (intermediate);
     for (i = 0; i < length; i += 4) {
         unsigned char alpha;
         unsigned char pixel[4];
@@ -3402,8 +3942,8 @@ rsvg_filter_primitive_image_render_ext (RsvgFilterPrimitive * self, RsvgFilterCo
             pixels[i + ch] = pixel[ch];
     }
 
+    cairo_surface_mark_dirty (intermediate);
     return intermediate;
-
 }
 
 static void
@@ -3412,8 +3952,9 @@ rsvg_filter_primitive_image_render (RsvgFilterPrimitive * self, RsvgFilterContex
     RsvgIRect boundarys;
     RsvgFilterPrimitiveImage *upself;
     RsvgFilterPrimitiveOutput op;
+    int x, y;
 
-    GdkPixbuf *output, *img;
+    cairo_surface_t *output, *img;
 
     upself = (RsvgFilterPrimitiveImage *) self;
 
@@ -3422,48 +3963,53 @@ rsvg_filter_primitive_image_render (RsvgFilterPrimitive * self, RsvgFilterContex
 
     boundarys = rsvg_filter_primitive_get_bounds (self, ctx);
 
-    output = _rsvg_pixbuf_new_cleared (GDK_COLORSPACE_RGB, 1, 8, ctx->width, ctx->height);
+    output = _rsvg_image_surface_new (ctx->width, ctx->height);
+    if (output == NULL)
+        return;
 
     img = rsvg_filter_primitive_image_render_in (self, ctx);
     if (img == NULL) {
         img = rsvg_filter_primitive_image_render_ext (self, ctx);
-        if (img) {
-            gdk_pixbuf_copy_area (img, 0, 0,
-                                  boundarys.x1 - boundarys.x0,
-                                  boundarys.y1 - boundarys.y0, output, boundarys.x0, boundarys.y0);
-            g_object_unref (G_OBJECT (img));
-        }
+        x = y = 0;
     } else {
-        gdk_pixbuf_copy_area (img, boundarys.x0, boundarys.y0, boundarys.x1 - boundarys.x0,
-                              boundarys.y1 - boundarys.y0, output, boundarys.x0, boundarys.y0);
-        g_object_unref (G_OBJECT (img));
+        x = boundarys.x0;
+        y = boundarys.y0;
+    }
+    if (img) {
+        cairo_t *cr;
+
+        cr = cairo_create (output);
+        cairo_set_source_surface (cr, img, x, y);
+        cairo_rectangle (cr, 0, 0,
+                         boundarys.x1 - boundarys.x0,
+                         boundarys.y1 - boundarys.y0);
+        cairo_clip (cr);
+        cairo_translate (cr, -boundarys.x0, -boundarys.y0);
+        cairo_paint (cr);
+        cairo_destroy (cr);
+
+        cairo_surface_destroy (img);
     }
 
-    op.result = output;
+    op.surface = output;
     op.bounds = boundarys;
-    op.Rused = 1;
-    op.Gused = 1;
-    op.Bused = 1;
-    op.Aused = 1;
 
     rsvg_filter_store_output (self->result, op, ctx);
 
-    g_object_unref (G_OBJECT (output));
+    cairo_surface_destroy (output);
 }
 
 static void
 rsvg_filter_primitive_image_free (RsvgNode * self)
 {
-    RsvgFilterPrimitiveImage *upself;
+    RsvgFilterPrimitiveImage *image;
 
-    upself = (RsvgFilterPrimitiveImage *) self;
-    g_string_free (upself->super.result, TRUE);
-    g_string_free (upself->super.in, TRUE);
+    image = (RsvgFilterPrimitiveImage *) self;
 
-    if (upself->href)
-        g_string_free (upself->href, TRUE);
+    if (image->href)
+        g_string_free (image->href, TRUE);
 
-    _rsvg_node_free (self);
+    rsvg_filter_primitive_free (self);
 }
 
 static void
@@ -3502,14 +4048,15 @@ rsvg_new_filter_primitive_image (void)
 {
     RsvgFilterPrimitiveImage *filter;
     filter = g_new (RsvgFilterPrimitiveImage, 1);
-    _rsvg_node_init (&filter->super.super);
+    _rsvg_node_init (&filter->super.super, RSVG_NODE_TYPE_FILTER_PRIMITIVE_IMAGE);
     filter->super.in = g_string_new ("none");
     filter->super.result = g_string_new ("none");
     filter->super.x.factor = filter->super.y.factor = filter->super.width.factor =
         filter->super.height.factor = 'n';
-    filter->super.render = &rsvg_filter_primitive_image_render;
-    filter->super.super.free = &rsvg_filter_primitive_image_free;
+    filter->super.render = rsvg_filter_primitive_image_render;
+    filter->super.super.free = rsvg_filter_primitive_image_free;
     filter->super.super.set_atts = rsvg_filter_primitive_image_set_atts;
+    filter->href = NULL;
     return (RsvgNode *) filter;
 }
 
@@ -3703,59 +4250,59 @@ get_surface_normal (guchar * I, RsvgIRect boundarys, gint x, gint y,
 
     Nx = -surfaceScale * factorx * ((gdouble)
                                     (Kx[0] *
-                                     gdk_pixbuf_get_interp_pixel (I, x - dx, y - dy, chan,
+                                     get_interp_pixel (I, x - dx, y - dy, chan,
                                                                   boundarys,
                                                                   rowstride) +
-                                     Kx[1] * gdk_pixbuf_get_interp_pixel (I, x, y - dy, chan,
+                                     Kx[1] * get_interp_pixel (I, x, y - dy, chan,
                                                                           boundarys,
                                                                           rowstride) +
-                                     Kx[2] * gdk_pixbuf_get_interp_pixel (I, x + dx, y - dy, chan,
+                                     Kx[2] * get_interp_pixel (I, x + dx, y - dy, chan,
                                                                           boundarys,
                                                                           rowstride) +
-                                     Kx[3] * gdk_pixbuf_get_interp_pixel (I, x - dx, y, chan,
+                                     Kx[3] * get_interp_pixel (I, x - dx, y, chan,
                                                                           boundarys,
                                                                           rowstride) +
-                                     Kx[4] * gdk_pixbuf_get_interp_pixel (I, x, y, chan, boundarys,
+                                     Kx[4] * get_interp_pixel (I, x, y, chan, boundarys,
                                                                           rowstride) +
-                                     Kx[5] * gdk_pixbuf_get_interp_pixel (I, x + dx, y, chan,
+                                     Kx[5] * get_interp_pixel (I, x + dx, y, chan,
                                                                           boundarys,
                                                                           rowstride) +
-                                     Kx[6] * gdk_pixbuf_get_interp_pixel (I, x - dx, y + dy, chan,
+                                     Kx[6] * get_interp_pixel (I, x - dx, y + dy, chan,
                                                                           boundarys,
                                                                           rowstride) +
-                                     Kx[7] * gdk_pixbuf_get_interp_pixel (I, x, y + dy, chan,
+                                     Kx[7] * get_interp_pixel (I, x, y + dy, chan,
                                                                           boundarys,
                                                                           rowstride) +
-                                     Kx[8] * gdk_pixbuf_get_interp_pixel (I, x + dx, y + dy, chan,
+                                     Kx[8] * get_interp_pixel (I, x + dx, y + dy, chan,
                                                                           boundarys,
                                                                           rowstride))) / 255.0;
 
     Ny = -surfaceScale * factory * ((gdouble)
                                     (Ky[0] *
-                                     gdk_pixbuf_get_interp_pixel (I, x - dx, y - dy, chan,
+                                     get_interp_pixel (I, x - dx, y - dy, chan,
                                                                   boundarys,
                                                                   rowstride) +
-                                     Ky[1] * gdk_pixbuf_get_interp_pixel (I, x, y - dy, chan,
+                                     Ky[1] * get_interp_pixel (I, x, y - dy, chan,
                                                                           boundarys,
                                                                           rowstride) +
-                                     Ky[2] * gdk_pixbuf_get_interp_pixel (I, x + dx, y - dy, chan,
+                                     Ky[2] * get_interp_pixel (I, x + dx, y - dy, chan,
                                                                           boundarys,
                                                                           rowstride) +
-                                     Ky[3] * gdk_pixbuf_get_interp_pixel (I, x - dx, y, chan,
+                                     Ky[3] * get_interp_pixel (I, x - dx, y, chan,
                                                                           boundarys,
                                                                           rowstride) +
-                                     Ky[4] * gdk_pixbuf_get_interp_pixel (I, x, y, chan, boundarys,
+                                     Ky[4] * get_interp_pixel (I, x, y, chan, boundarys,
                                                                           rowstride) +
-                                     Ky[5] * gdk_pixbuf_get_interp_pixel (I, x + dx, y, chan,
+                                     Ky[5] * get_interp_pixel (I, x + dx, y, chan,
                                                                           boundarys,
                                                                           rowstride) +
-                                     Ky[6] * gdk_pixbuf_get_interp_pixel (I, x - dx, y + dy, chan,
+                                     Ky[6] * get_interp_pixel (I, x - dx, y + dy, chan,
                                                                           boundarys,
                                                                           rowstride) +
-                                     Ky[7] * gdk_pixbuf_get_interp_pixel (I, x, y + dy, chan,
+                                     Ky[7] * get_interp_pixel (I, x, y + dy, chan,
                                                                           boundarys,
                                                                           rowstride) +
-                                     Ky[8] * gdk_pixbuf_get_interp_pixel (I, x + dx, y + dy, chan,
+                                     Ky[8] * get_interp_pixel (I, x + dx, y + dy, chan,
                                                                           boundarys,
                                                                           rowstride))) / 255.0;
 
@@ -3785,7 +4332,7 @@ struct _RsvgNodeLightSource {
 
 static vector3
 get_light_direction (RsvgNodeLightSource * source, gdouble x1, gdouble y1, gdouble z,
-                     gdouble * affine, RsvgDrawingCtx * ctx)
+                     cairo_matrix_t *affine, RsvgDrawingCtx * ctx)
 {
     vector3 output;
 
@@ -3798,8 +4345,8 @@ get_light_direction (RsvgNodeLightSource * source, gdouble x1, gdouble y1, gdoub
     default:
         {
             double x, y;
-            x = affine[0] * x1 + affine[2] * y1 + affine[4];
-            y = affine[1] * x1 + affine[3] * y1 + affine[5];
+            x = affine->xx * x1 + affine->xy * y1 + affine->x0;
+            y = affine->yx * x1 + affine->yy * y1 + affine->y0;
             output.x = _rsvg_css_normalize_length (&source->x, ctx, 'h') - x;
             output.y = _rsvg_css_normalize_length (&source->y, ctx, 'v') - y;
             output.z = _rsvg_css_normalize_length (&source->z, ctx, 'o') - z;
@@ -3811,8 +4358,8 @@ get_light_direction (RsvgNodeLightSource * source, gdouble x1, gdouble y1, gdoub
 }
 
 static vector3
-get_light_colour (RsvgNodeLightSource * source, vector3 colour,
-                  gdouble x1, gdouble y1, gdouble z, gdouble * affine, RsvgDrawingCtx * ctx)
+get_light_color (RsvgNodeLightSource * source, vector3 color,
+                  gdouble x1, gdouble y1, gdouble z, cairo_matrix_t *affine, RsvgDrawingCtx * ctx)
 {
     double base, angle, x, y;
     vector3 s;
@@ -3821,7 +4368,7 @@ get_light_colour (RsvgNodeLightSource * source, vector3 colour,
     double sx, sy, sz, spx, spy, spz;
 
     if (source->type != SPOTLIGHT)
-        return colour;
+        return color;
 
     sx = _rsvg_css_normalize_length (&source->x, ctx, 'h');
     sy = _rsvg_css_normalize_length (&source->y, ctx, 'v');
@@ -3830,8 +4377,8 @@ get_light_colour (RsvgNodeLightSource * source, vector3 colour,
     spy = _rsvg_css_normalize_length (&source->pointsAtY, ctx, 'v');
     spz = _rsvg_css_normalize_length (&source->pointsAtZ, ctx, 'o');
 
-    x = affine[0] * x1 + affine[2] * y1 + affine[4];
-    y = affine[1] * x1 + affine[3] * y1 + affine[5];
+    x = affine->xx * x1 + affine->xy * y1 + affine->x0;
+    y = affine->yx * x1 + affine->yy * y1 + affine->y0;
 
     L.x = sx - x;
     L.y = sy - y;
@@ -3845,7 +4392,7 @@ get_light_colour (RsvgNodeLightSource * source, vector3 colour,
 
     base = -dotproduct (L, s);
 
-    angle = acos (base) * 180.0 / M_PI;
+    angle = acos (base);
 
     if (base < 0 || angle > source->limitingconeAngle) {
         output.x = 0;
@@ -3854,17 +4401,17 @@ get_light_colour (RsvgNodeLightSource * source, vector3 colour,
         return output;
     }
 
-    output.x = colour.x * pow (base, source->specularExponent);
-    output.y = colour.y * pow (base, source->specularExponent);
-    output.z = colour.z * pow (base, source->specularExponent);
+    output.x = color.x * pow (base, source->specularExponent);
+    output.y = color.y * pow (base, source->specularExponent);
+    output.z = color.z * pow (base, source->specularExponent);
 
     return output;
 }
 
 
 static void
-rsvg_filter_primitive_light_source_set_atts (RsvgNode * self,
-                                             RsvgHandle * ctx, RsvgPropertyBag * atts)
+rsvg_node_light_source_set_atts (RsvgNode * self,
+                                 RsvgHandle * ctx, RsvgPropertyBag * atts)
 {
     RsvgNodeLightSource *data;
     const char *value;
@@ -3877,7 +4424,7 @@ rsvg_filter_primitive_light_source_set_atts (RsvgNode * self,
         if ((value = rsvg_property_bag_lookup (atts, "elevation")))
             data->elevation = rsvg_css_parse_angle (value) / 180.0 * M_PI;
         if ((value = rsvg_property_bag_lookup (atts, "limitingConeAngle")))
-            data->limitingconeAngle = rsvg_css_parse_angle (value);
+            data->limitingconeAngle = rsvg_css_parse_angle (value) / 180.0 * M_PI;
         if ((value = rsvg_property_bag_lookup (atts, "x")))
             data->x = data->pointsAtX = _rsvg_css_parse_length (value);
         if ((value = rsvg_property_bag_lookup (atts, "y")))
@@ -3896,13 +4443,13 @@ rsvg_filter_primitive_light_source_set_atts (RsvgNode * self,
 }
 
 RsvgNode *
-rsvg_new_filter_primitive_light_source (char type)
+rsvg_new_node_light_source (char type)
 {
     RsvgNodeLightSource *data;
     data = g_new (RsvgNodeLightSource, 1);
-    _rsvg_node_init (&data->super);
+    _rsvg_node_init (&data->super, RSVG_NODE_TYPE_LIGHT_SOURCE);
     data->super.free = _rsvg_node_free;
-    data->super.set_atts = rsvg_filter_primitive_light_source_set_atts;
+    data->super.set_atts = rsvg_node_light_source_set_atts;
     data->specularExponent = 1;
     if (type == 's')
         data->type = SPOTLIGHT;
@@ -3924,7 +4471,7 @@ struct _RsvgFilterPrimitiveDiffuseLighting {
     gdouble dx, dy;
     double diffuseConstant;
     double surfaceScale;
-    guint32 lightingcolour;
+    guint32 lightingcolor;
 };
 
 static void
@@ -3935,9 +4482,9 @@ rsvg_filter_primitive_diffuse_lighting_render (RsvgFilterPrimitive * self, RsvgF
     gdouble z;
     gint rowstride, height, width;
     gdouble factor, surfaceScale;
-    vector3 lightcolour, L, N;
-    vector3 colour;
-    gdouble iaffine[6];
+    vector3 lightcolor, L, N;
+    vector3 color;
+    cairo_matrix_t iaffine;
     RsvgNodeLightSource *source = NULL;
     RsvgIRect boundarys;
 
@@ -3946,38 +4493,52 @@ rsvg_filter_primitive_diffuse_lighting_render (RsvgFilterPrimitive * self, RsvgF
 
     RsvgFilterPrimitiveDiffuseLighting *upself;
 
-    GdkPixbuf *output;
-    GdkPixbuf *in;
+    cairo_surface_t *output, *in;
+
     unsigned int i;
 
     for (i = 0; i < self->super.children->len; i++) {
         RsvgNode *temp;
+
         temp = g_ptr_array_index (self->super.children, i);
-        if (!strcmp (temp->type->str, "feDistantLight") ||
-            !strcmp (temp->type->str, "fePointLight") || !strcmp (temp->type->str, "feSpotLight"))
+        if (RSVG_NODE_TYPE (temp) == RSVG_NODE_TYPE_LIGHT_SOURCE) {
             source = (RsvgNodeLightSource *) temp;
+        }
     }
     if (source == NULL)
         return;
 
+    iaffine = ctx->paffine;
+    if (cairo_matrix_invert (&iaffine) != CAIRO_STATUS_SUCCESS)
+      return;
+
     upself = (RsvgFilterPrimitiveDiffuseLighting *) self;
     boundarys = rsvg_filter_primitive_get_bounds (self, ctx);
 
     in = rsvg_filter_get_in (self->in, ctx);
-    in_pixels = gdk_pixbuf_get_pixels (in);
+    if (in == NULL)
+        return;
 
-    height = gdk_pixbuf_get_height (in);
-    width = gdk_pixbuf_get_width (in);
+    cairo_surface_flush (in);
 
-    rowstride = gdk_pixbuf_get_rowstride (in);
+    in_pixels = cairo_image_surface_get_data (in);
 
-    output = _rsvg_pixbuf_new_cleared (GDK_COLORSPACE_RGB, 1, 8, width, height);
+    height = cairo_image_surface_get_height (in);
+    width = cairo_image_surface_get_width (in);
 
-    output_pixels = gdk_pixbuf_get_pixels (output);
+    rowstride = cairo_image_surface_get_stride (in);
 
-    colour.x = ((guchar *) (&upself->lightingcolour))[2] / 255.0;
-    colour.y = ((guchar *) (&upself->lightingcolour))[1] / 255.0;
-    colour.z = ((guchar *) (&upself->lightingcolour))[0] / 255.0;
+    output = _rsvg_image_surface_new (width, height);
+    if (output == NULL) {
+        cairo_surface_destroy (in);
+        return;
+    }
+
+    output_pixels = cairo_image_surface_get_data (output);
+
+    color.x = ((guchar *) (&upself->lightingcolor))[2] / 255.0;
+    color.y = ((guchar *) (&upself->lightingcolor))[1] / 255.0;
+    color.z = ((guchar *) (&upself->lightingcolor))[0] / 255.0;
 
     surfaceScale = upself->surfaceScale / 255.0;
 
@@ -3987,48 +4548,37 @@ rsvg_filter_primitive_diffuse_lighting_render (RsvgFilterPrimitive * self, RsvgF
         rawdx = 1;
         rawdy = 1;
     } else {
-        dx = upself->dx * ctx->paffine[0];
-        dy = upself->dy * ctx->paffine[3];
+        dx = upself->dx * ctx->paffine.xx;
+        dy = upself->dy * ctx->paffine.yy;
         rawdx = upself->dx;
         rawdy = upself->dy;
     }
 
-    _rsvg_affine_invert (iaffine, ctx->paffine);
-
     for (y = boundarys.y0; y < boundarys.y1; y++)
         for (x = boundarys.x0; x < boundarys.x1; x++) {
             z = surfaceScale * (double) in_pixels[y * rowstride + x * 4 + ctx->channelmap[3]];
-            L = get_light_direction (source, x, y, z, iaffine, ctx->ctx);
+            L = get_light_direction (source, x, y, z, &iaffine, ctx->ctx);
             N = get_surface_normal (in_pixels, boundarys, x, y,
                                     dx, dy, rawdx, rawdy, upself->surfaceScale,
                                     rowstride, ctx->channelmap[3]);
-            lightcolour = get_light_colour (source, colour, x, y, z, iaffine, ctx->ctx);
+            lightcolor = get_light_color (source, color, x, y, z, &iaffine, ctx->ctx);
             factor = dotproduct (N, L);
 
             output_pixels[y * rowstride + x * 4 + ctx->channelmap[0]] =
-                MAX (0, MIN (255, upself->diffuseConstant * factor * lightcolour.x * 255.0));
+                MAX (0, MIN (255, upself->diffuseConstant * factor * lightcolor.x * 255.0));
             output_pixels[y * rowstride + x * 4 + ctx->channelmap[1]] =
-                MAX (0, MIN (255, upself->diffuseConstant * factor * lightcolour.y * 255.0));
+                MAX (0, MIN (255, upself->diffuseConstant * factor * lightcolor.y * 255.0));
             output_pixels[y * rowstride + x * 4 + ctx->channelmap[2]] =
-                MAX (0, MIN (255, upself->diffuseConstant * factor * lightcolour.z * 255.0));
+                MAX (0, MIN (255, upself->diffuseConstant * factor * lightcolor.z * 255.0));
             output_pixels[y * rowstride + x * 4 + ctx->channelmap[3]] = 255;
         }
 
-    rsvg_filter_store_result (self->result, output, ctx);
-
-    g_object_unref (G_OBJECT (in));
-    g_object_unref (G_OBJECT (output));
-}
+    cairo_surface_mark_dirty (output);
 
-static void
-rsvg_filter_primitive_diffuse_lighting_free (RsvgNode * self)
-{
-    RsvgFilterPrimitiveDiffuseLighting *upself;
+    rsvg_filter_store_result (self->result, output, ctx);
 
-    upself = (RsvgFilterPrimitiveDiffuseLighting *) self;
-    g_string_free (upself->super.result, TRUE);
-    g_string_free (upself->super.in, TRUE);
-    _rsvg_node_free (self);
+    cairo_surface_destroy (in);
+    cairo_surface_destroy (output);
 }
 
 static void
@@ -4057,7 +4607,7 @@ rsvg_filter_primitive_diffuse_lighting_set_atts (RsvgNode * self, RsvgHandle * c
         if ((value = rsvg_property_bag_lookup (atts, "kernelUnitLength")))
             rsvg_css_parse_number_optional_number (value, &filter->dx, &filter->dy);
         if ((value = rsvg_property_bag_lookup (atts, "lighting-color")))
-            filter->lightingcolour = rsvg_css_parse_color (value, 0);
+            filter->lightingcolor = rsvg_css_parse_color (value, 0);
         if ((value = rsvg_property_bag_lookup (atts, "diffuseConstant")))
             filter->diffuseConstant = g_ascii_strtod (value, NULL);
         if ((value = rsvg_property_bag_lookup (atts, "surfaceScale")))
@@ -4072,7 +4622,7 @@ rsvg_new_filter_primitive_diffuse_lighting (void)
 {
     RsvgFilterPrimitiveDiffuseLighting *filter;
     filter = g_new (RsvgFilterPrimitiveDiffuseLighting, 1);
-    _rsvg_node_init (&filter->super.super);
+    _rsvg_node_init (&filter->super.super, RSVG_NODE_TYPE_FILTER_PRIMITIVE_DIFFUSE_LIGHTING);
     filter->super.in = g_string_new ("none");
     filter->super.result = g_string_new ("none");
     filter->super.x.factor = filter->super.y.factor = filter->super.width.factor =
@@ -4081,9 +4631,9 @@ rsvg_new_filter_primitive_diffuse_lighting (void)
     filter->diffuseConstant = 1;
     filter->dx = 1;
     filter->dy = 1;
-    filter->lightingcolour = 0xFFFFFFFF;
-    filter->super.render = &rsvg_filter_primitive_diffuse_lighting_render;
-    filter->super.super.free = &rsvg_filter_primitive_diffuse_lighting_free;
+    filter->lightingcolor = 0xFFFFFFFF;
+    filter->super.render = rsvg_filter_primitive_diffuse_lighting_render;
+    filter->super.super.free = rsvg_filter_primitive_free;
     filter->super.super.set_atts = rsvg_filter_primitive_diffuse_lighting_set_atts;
     return (RsvgNode *) filter;
 }
@@ -4098,7 +4648,7 @@ struct _RsvgFilterPrimitiveSpecularLighting {
     double specularConstant;
     double specularExponent;
     double surfaceScale;
-    guint32 lightingcolour;
+    guint32 lightingcolor;
 };
 
 static void
@@ -4108,9 +4658,9 @@ rsvg_filter_primitive_specular_lighting_render (RsvgFilterPrimitive * self, Rsvg
     gdouble z, surfaceScale;
     gint rowstride, height, width;
     gdouble factor, max, base;
-    vector3 lightcolour, colour;
+    vector3 lightcolor, color;
     vector3 L;
-    gdouble iaffine[6];
+    cairo_matrix_t iaffine;
     RsvgIRect boundarys;
     RsvgNodeLightSource *source = NULL;
 
@@ -4119,66 +4669,76 @@ rsvg_filter_primitive_specular_lighting_render (RsvgFilterPrimitive * self, Rsvg
 
     RsvgFilterPrimitiveSpecularLighting *upself;
 
-    GdkPixbuf *output;
-    GdkPixbuf *in;
+    cairo_surface_t *output, *in;
 
     unsigned int i;
 
     for (i = 0; i < self->super.children->len; i++) {
         RsvgNode *temp;
         temp = g_ptr_array_index (self->super.children, i);
-        if (!strcmp (temp->type->str, "feDistantLight") ||
-            !strcmp (temp->type->str, "fePointLight") || !strcmp (temp->type->str, "feSpotLight"))
+        if (RSVG_NODE_TYPE (temp) == RSVG_NODE_TYPE_LIGHT_SOURCE) {
             source = (RsvgNodeLightSource *) temp;
+        }
     }
     if (source == NULL)
         return;
 
+    iaffine = ctx->paffine;
+    if (cairo_matrix_invert (&iaffine) != CAIRO_STATUS_SUCCESS)
+      return;
+
     upself = (RsvgFilterPrimitiveSpecularLighting *) self;
     boundarys = rsvg_filter_primitive_get_bounds (self, ctx);
 
     in = rsvg_filter_get_in (self->in, ctx);
-    in_pixels = gdk_pixbuf_get_pixels (in);
+    if (in == NULL)
+        return;
 
-    height = gdk_pixbuf_get_height (in);
-    width = gdk_pixbuf_get_width (in);
+    cairo_surface_flush (in);
 
-    rowstride = gdk_pixbuf_get_rowstride (in);
+    in_pixels = cairo_image_surface_get_data (in);
 
-    output = _rsvg_pixbuf_new_cleared (GDK_COLORSPACE_RGB, 1, 8, width, height);
+    height = cairo_image_surface_get_height (in);
+    width = cairo_image_surface_get_width (in);
 
-    output_pixels = gdk_pixbuf_get_pixels (output);
+    rowstride = cairo_image_surface_get_stride (in);
 
-    colour.x = ((guchar *) (&upself->lightingcolour))[2] / 255.0;
-    colour.y = ((guchar *) (&upself->lightingcolour))[1] / 255.0;
-    colour.z = ((guchar *) (&upself->lightingcolour))[0] / 255.0;
+    output = _rsvg_image_surface_new (width, height);
+    if (output == NULL) {
+        cairo_surface_destroy (in);
+        return;
+    }
 
-    surfaceScale = upself->surfaceScale / 255.0;
+    output_pixels = cairo_image_surface_get_data (output);
+
+    color.x = ((guchar *) (&upself->lightingcolor))[2] / 255.0;
+    color.y = ((guchar *) (&upself->lightingcolor))[1] / 255.0;
+    color.z = ((guchar *) (&upself->lightingcolor))[0] / 255.0;
 
-    _rsvg_affine_invert (iaffine, ctx->paffine);
+    surfaceScale = upself->surfaceScale / 255.0;
 
     for (y = boundarys.y0; y < boundarys.y1; y++)
         for (x = boundarys.x0; x < boundarys.x1; x++) {
             z = in_pixels[y * rowstride + x * 4 + 3] * surfaceScale;
-            L = get_light_direction (source, x, y, z, iaffine, ctx->ctx);
+            L = get_light_direction (source, x, y, z, &iaffine, ctx->ctx);
             L.z += 1;
             L = normalise (L);
 
-            lightcolour = get_light_colour (source, colour, x, y, z, iaffine, ctx->ctx);
+            lightcolor = get_light_color (source, color, x, y, z, &iaffine, ctx->ctx);
             base = dotproduct (get_surface_normal (in_pixels, boundarys, x, y,
-                                                   1, 1, 1.0 / ctx->paffine[0],
-                                                   1.0 / ctx->paffine[3], upself->surfaceScale,
+                                                   1, 1, 1.0 / ctx->paffine.xx,
+                                                   1.0 / ctx->paffine.yy, upself->surfaceScale,
                                                    rowstride, ctx->channelmap[3]), L);
 
             factor = upself->specularConstant * pow (base, upself->specularExponent) * 255;
 
             max = 0;
-            if (max < lightcolour.x)
-                max = lightcolour.x;
-            if (max < lightcolour.y)
-                max = lightcolour.y;
-            if (max < lightcolour.z)
-                max = lightcolour.z;
+            if (max < lightcolor.x)
+                max = lightcolor.x;
+            if (max < lightcolor.y)
+                max = lightcolor.y;
+            if (max < lightcolor.z)
+                max = lightcolor.z;
 
             max *= factor;
             if (max > 255)
